/* Generated automatically by the program 'build/genpreds'
   from the machine description file '../../gcc-4.5.0/gcc/config/avr/avr.md'.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "tree.h"
#include "tm_p.h"
#include "function.h"
#include "insn-config.h"
#include "recog.h"
#include "real.h"
#include "output.h"
#include "flags.h"
#include "hard-reg-set.h"
#include "resource.h"
#include "toplev.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"

int
l_register_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && (
#line 23 "../../gcc-4.5.0/gcc/config/avr/predicates.md"
(REGNO (op) <= 15))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

int
d_register_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && (
#line 28 "../../gcc-4.5.0/gcc/config/avr/predicates.md"
(REGNO (op) >= 16 && REGNO (op) <= 31))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

int
even_register_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && ((
#line 32 "../../gcc-4.5.0/gcc/config/avr/predicates.md"
(REGNO (op) <= 31)) && (
#line 33 "../../gcc-4.5.0/gcc/config/avr/predicates.md"
((REGNO (op) & 1) == 0)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

int
odd_register_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && ((
#line 37 "../../gcc-4.5.0/gcc/config/avr/predicates.md"
(REGNO (op) <= 31)) && (
#line 38 "../../gcc-4.5.0/gcc/config/avr/predicates.md"
((REGNO (op) & 1) != 0)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

int
stack_register_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && (
#line 43 "../../gcc-4.5.0/gcc/config/avr/predicates.md"
(REGNO (op) == REG_SP))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

int
low_io_address_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 48 "../../gcc-4.5.0/gcc/config/avr/predicates.md"
(IN_RANGE((INTVAL (op)), 0x20, 0x3F)));
}

int
high_io_address_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 53 "../../gcc-4.5.0/gcc/config/avr/predicates.md"
(IN_RANGE((INTVAL (op)), 0x40, 0x5F)));
}

int
io_address_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 58 "../../gcc-4.5.0/gcc/config/avr/predicates.md"
(IN_RANGE((INTVAL (op)), 0x20, (0x60 - GET_MODE_SIZE(mode)))));
}

int
const0_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case CONST_INT:
    case CONST_DOUBLE:
      break;
    default:
      return false;
    }
  return 
#line 63 "../../gcc-4.5.0/gcc/config/avr/predicates.md"
(op == CONST0_RTX (mode));
}

int
reg_or_0_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (register_operand (op, mode)) || (const0_operand (op, mode));
}

int
symbol_ref_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == SYMBOL_REF) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline int
text_segment_operand_1 (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
#line 78 "../../gcc-4.5.0/gcc/config/avr/predicates.md"
{
  switch (GET_CODE (op))
    {
    case CODE_LABEL:
      return true;
    case LABEL_REF :
      return true;
    case SYMBOL_REF :
      return SYMBOL_REF_FUNCTION_P (op);
    case PLUS :
      /* Assume canonical format of symbol + constant.
	 Fall through.  */
    case CONST :
      return text_segment_operand (XEXP (op, 0), VOIDmode);
    default :
      return false;
    }
}

int
text_segment_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case CODE_LABEL:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case CONST:
      break;
    default:
      return false;
    }
  return (
(text_segment_operand_1 (op, mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

int
single_one_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 101 "../../gcc-4.5.0/gcc/config/avr/predicates.md"
(exact_log2(INTVAL (op) & GET_MODE_MASK (mode)) >= 0));
}

int
single_zero_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 107 "../../gcc-4.5.0/gcc/config/avr/predicates.md"
(exact_log2(~INTVAL (op) & GET_MODE_MASK (mode)) >= 0));
}

int
avr_sp_immediate_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 112 "../../gcc-4.5.0/gcc/config/avr/predicates.md"
(INTVAL (op) >= -6 && INTVAL (op) <= 5));
}

int
eqne_operator (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case EQ:
    case NE:
      break;
    default:
      return false;
    }
  return 
(mode == VOIDmode || GET_MODE (op) == mode);
}

int
gelt_operator (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case GE:
    case LT:
      break;
    default:
      return false;
    }
  return 
(mode == VOIDmode || GET_MODE (op) == mode);
}

int
difficult_comparison_operator (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case GT:
    case GTU:
    case LE:
    case LEU:
      break;
    default:
      return false;
    }
  return 
(mode == VOIDmode || GET_MODE (op) == mode);
}

int
simple_comparison_operator (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (comparison_operator (op, mode)) && (!(GET_CODE (op) == GT || GET_CODE (op) == GTU || GET_CODE (op) == LE || GET_CODE (op) == LEU));
}

int
call_insn_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == MEM) && ((
#line 134 "../../gcc-4.5.0/gcc/config/avr/predicates.md"
(register_operand (XEXP (op, 0), mode))) || (
#line 135 "../../gcc-4.5.0/gcc/config/avr/predicates.md"
(CONSTANT_ADDRESS_P (XEXP (op, 0)))))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

int
pseudo_register_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && (
#line 140 "../../gcc-4.5.0/gcc/config/avr/predicates.md"
(!HARD_REGISTER_P (op)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

enum constraint_num
lookup_constraint (const char *str)
{
  switch (str[0])
    {
    case 'G':
      return CONSTRAINT_G;
    case 'I':
      return CONSTRAINT_I;
    case 'J':
      return CONSTRAINT_J;
    case 'K':
      return CONSTRAINT_K;
    case 'L':
      return CONSTRAINT_L;
    case 'M':
      return CONSTRAINT_M;
    case 'N':
      return CONSTRAINT_N;
    case 'O':
      return CONSTRAINT_O;
    case 'P':
      return CONSTRAINT_P;
    case 'Q':
      return CONSTRAINT_Q;
    case 'R':
      return CONSTRAINT_R;
    case 'a':
      return CONSTRAINT_a;
    case 'b':
      return CONSTRAINT_b;
    case 'd':
      return CONSTRAINT_d;
    case 'e':
      return CONSTRAINT_e;
    case 'l':
      return CONSTRAINT_l;
    case 'q':
      return CONSTRAINT_q;
    case 't':
      return CONSTRAINT_t;
    case 'w':
      return CONSTRAINT_w;
    case 'x':
      return CONSTRAINT_x;
    case 'y':
      return CONSTRAINT_y;
    case 'z':
      return CONSTRAINT_z;
    default: break;
    }
  return CONSTRAINT__UNKNOWN;
}

enum reg_class
regclass_for_constraint (enum constraint_num c)
{
  switch (c)
    {
    case CONSTRAINT_t: return R0_REG;
    case CONSTRAINT_b: return BASE_POINTER_REGS;
    case CONSTRAINT_e: return POINTER_REGS;
    case CONSTRAINT_w: return ADDW_REGS;
    case CONSTRAINT_d: return LD_REGS;
    case CONSTRAINT_l: return NO_LD_REGS;
    case CONSTRAINT_a: return SIMPLE_LD_REGS;
    case CONSTRAINT_x: return POINTER_X_REGS;
    case CONSTRAINT_y: return POINTER_Y_REGS;
    case CONSTRAINT_z: return POINTER_Z_REGS;
    case CONSTRAINT_q: return STACK_REG;
    default: break;
    }
  return NO_REGS;
}

bool
constraint_satisfied_p (rtx op, enum constraint_num c)
{
  switch (c)
    {
    case CONSTRAINT_I: return satisfies_constraint_I (op);
    case CONSTRAINT_J: return satisfies_constraint_J (op);
    case CONSTRAINT_K: return satisfies_constraint_K (op);
    case CONSTRAINT_L: return satisfies_constraint_L (op);
    case CONSTRAINT_M: return satisfies_constraint_M (op);
    case CONSTRAINT_N: return satisfies_constraint_N (op);
    case CONSTRAINT_O: return satisfies_constraint_O (op);
    case CONSTRAINT_P: return satisfies_constraint_P (op);
    case CONSTRAINT_G: return satisfies_constraint_G (op);
    case CONSTRAINT_R: return satisfies_constraint_R (op);
    case CONSTRAINT_Q: return satisfies_constraint_Q (op);
    default: break;
    }
  return false;
}

bool
insn_const_int_ok_for_constraint (HOST_WIDE_INT ival, enum constraint_num c)
{
  switch (c)
    {
    case CONSTRAINT_I:
      return 
#line 59 "../../gcc-4.5.0/gcc/config/avr/constraints.md"
(ival >= 0 && ival <= 63);

    case CONSTRAINT_J:
      return 
#line 64 "../../gcc-4.5.0/gcc/config/avr/constraints.md"
(ival <= 0 && ival >= -63);

    case CONSTRAINT_K:
      return 
#line 69 "../../gcc-4.5.0/gcc/config/avr/constraints.md"
(ival == 2);

    case CONSTRAINT_L:
      return 
#line 74 "../../gcc-4.5.0/gcc/config/avr/constraints.md"
(ival == 0);

    case CONSTRAINT_M:
      return 
#line 79 "../../gcc-4.5.0/gcc/config/avr/constraints.md"
(ival >= 0 && ival <= 0xff);

    case CONSTRAINT_N:
      return 
#line 84 "../../gcc-4.5.0/gcc/config/avr/constraints.md"
(ival == -1);

    case CONSTRAINT_O:
      return 
#line 89 "../../gcc-4.5.0/gcc/config/avr/constraints.md"
(ival == 8 || ival == 16 || ival == 24);

    case CONSTRAINT_P:
      return 
#line 94 "../../gcc-4.5.0/gcc/config/avr/constraints.md"
(ival == 1);

    default: break;
    }
  return false;
}

bool
insn_extra_memory_constraint (enum constraint_num c)
{
  switch (c)
    {
    case CONSTRAINT_Q:
      return true;

    default: break;
    }
  return false;
}

